<template>
  <div>
    <van-nav-bar
      left-text="Back"
      left-arrow
      @click-left="onClickBack"
    />
    <h1 class="org-header">{{getSelectedOrganization.name}}</h1>
    <section>

    </section>

    <p class="claims-header">Personal Claims</p>
    <van-cell-group>
      <van-field
        v-model="phone"
        required
        clearable
        label="Phone nr:"
        right-icon="question-o"
        placeholder=""
        @click-right-icon="$toast('Update this field to submit a request to change field.')"/>

      <van-field
        v-model="email"
        required
        clearable
        label="Email:"
        right-icon="question-o"
        placeholder=""
        @click-right-icon="$toast('Update this field to submit a request to change field.')"/>

    </van-cell-group>
    <van-button type="primary" @click="persistFields" round class="konsent-button"><span>Send update</span></van-button>

    <p class="claims-header">Organizational Claims</p>
    <van-list v-model="loading" :finished="finished">
      <van-cell v-for="item in listOfClaims" :key="item" :title="item"/>
    </van-list>

    <pre style="display: none">{{formatClaims}}</pre>
    <!-- <pre>{{listOfClaims}}</pre> -->

  </div>
</template>

<script>
import { mapGetters } from 'vuex';
import didJWT from 'did-jwt';

import {
  SET_NEW_CLAIMS, FETCH_ORGS_INIT, FETCH_ORG_CLAIMS, SET_SELECTED_ORG, SET_SELECTED_ORG_FROM_URL, basePath,
} from './actions';

export default {
  name: 'OrganizationClaims',
  props: ['id'],
  methods: {
    onClickBack() {
      this.$router.push({ path: '/organizations' });
    },
    persistFields() {
      this.$store.dispatch(basePath(SET_NEW_CLAIMS), { phone: this.phone, email: this.email });
    },
  },
  data() {
    return {
      listOfClaims: [],
      loading: false,
      finished: false,
      togglePhone: false,
      toggleEmail: false,
      mappings: [],
      phone: '',
      email: '',
    };
  },
  computed: {
    ...mapGetters('Organization', ['organizations', 'getOrganizationById', 'claims', 'getSelectedOrganization']),
    ...mapGetters('Installation', ['uuid']),
    ...mapGetters('Wallet', ['wallet', 'did']),
    formatClaims() {
      const jwts = this.claims.map(didJWT.decodeJWT);
      this.mappings = jwts.map(jwt => jwt.payload.claims);

      this.listOfClaims = [this.mappings[1] ? this.mappings[1][0].value : '', this.mappings[0] ? this.mappings[0][0].value : ''];

      this.loading = false;
      this.finished = true;
      return this.mappings ? this.mappings : [];
    },
  },
  created() {
    this.$store.dispatch(basePath(SET_SELECTED_ORG_FROM_URL), this.id);
    this.$store.dispatch(basePath(FETCH_ORGS_INIT));
    this.$store.dispatch(basePath(FETCH_ORG_CLAIMS), { userDid: this.did.did });
  },
  destroyed() {
  },
};
</script>

<style lang="less">
.organization {
  padding-bottom: 50px;
  &-swipe {
    img {
      width: 100%;
      display: block;
    }
  }
  &-title {
    font-size: 16px;
  }
  &-price {
    color: #f44;
  }
  &-express {
    color: #999;
    font-size: 12px;
    padding: 5px 15px;
  }
  &-cell-group {
    margin: 15px 0;
    margin-bottom: 150px;
    .van-cell__value {
      color: #999;
    }
  }
  &-tag {
    margin-left: 5px;
  }
}

.claims-header {
  color:white; font-weight:bold; margin-left: 1em;
}
</style>
